/*!
 *  @file MSG_BUFFER.h
 *
 *  @author Daniel Brockmann
 *  @date 13.05.2010
 *
 *  @version 0.1
 *
 *  @brief basic settings and functions for mesage queues
 *
*/

//! needed libraries for message queues
#include <iostream>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <stdio.h>
#include <sys/types.h>
#include <string>

//! \define SIZE size of char-array for message-buffer
//! \TODO delete??
//#define SIZE 512

////! \define KEY_DATA DATA-queue ID
//#define KEY_DATA 111
////! \define KEY_LAYER LAYER-queue ID
//#define KEY_LAYER 111
////! \define KEY_FKT FKT-queue ID
//#define KEY_FKT 111

//! \define KEY_WLME WLME-queue ID
#define KEY_WLME 111
//! \define KEY_ALME ALME-queue ID
#define KEY_ALME 112
//! \define KEY_MLME MLME-queue ID
#define KEY_MLME 113
//! \define KEY_PLME PLME-queue ID
#define KEY_PLME 114
//! \define KEY WLPSAP WLPSAP-queue ID
#define KEY_WLPSAP 115
//! \define KEY_MACSAP MACSAP-queue ID
#define KEY_MACSAP 116

//! \define KEY_WLME WLME_PARAMETER-queue ID
#define KEY_WLME_P 121
//! \define KEY_ALME ALME_PARAMETER-queue ID
#define KEY_ALME_P 122
//! \define KEY_MLME MLME_PARAMETER-queue ID
#define KEY_MLME_P 123
//! \define KEY_PLME PLME_PARAMETER-queue ID
#define KEY_PLME_P 124
//! \define KEY WLPSAP WLPSAP_PARAMETER-queue ID
#define KEY_WLPSAP_P 125
//! \define KEY_MACSAP MACSAP_PARAMETER-queue ID
#define KEY_MACSAP_P 126

#define SIZE 5

//! \struct MSGBUF structure for message transmit
typedef struct MSGBUF {
		int mtyp; //!< \var int mtyp: defines direction for receive messages (2=to DME, 1=from DME)
		int pid;
		char msg[SIZE]; //!< message field
};

//typedef struct MSGBUF2 {
//		int mtyp; //!< \var int mtyp: defines direction for receive messages (2=to DME, 1=from DME)
//		int pid;
//		char msg[80]; //!< message field
//};

/*!void MESSAGE_QUEUE_INIT
 * create different message queues ALME, WLME, MLME, PLME by DME
 * param[in] int* qid_ALME: pointer auf ALME message queue ID
 * param[in] int* qid_WLME: pointer auf WLME message queue ID
 * param[in] int* qid_MLME: pointer auf MLME message queue ID
 * param[in] int* qid_PLME: pointer auf PLME message queue ID
 */
void MESSAGE_QUEUE_INIT(int *qid_ALME, int *qid_WLME, int *qid_MLME, int *qid_PLME, int *qid_ALME_P, int *qid_WLME_P, int *qid_MLME_P, int *qid_PLME_P){

	//! realize access to message queue
//	*qid_LAYER = msgget(KEY_LAYER, 0600|IPC_CREAT);
//	*qid_FKT = msgget(KEY_FKT, 0600|IPC_CREAT);
	*qid_ALME = msgget(KEY_ALME, 0600|IPC_CREAT);
	*qid_WLME = msgget(KEY_WLME, 0600|IPC_CREAT);
	*qid_MLME = msgget(KEY_MLME, 0600|IPC_CREAT);
	*qid_PLME = msgget(KEY_PLME, 0600|IPC_CREAT);

//	*qid_ALME_P = msgget(KEY_ALME_P, 0600|IPC_CREAT);
//	*qid_WLME_P = msgget(KEY_WLME_P, 0600|IPC_CREAT);
//	*qid_MLME_P = msgget(KEY_MLME_P, 0600|IPC_CREAT);
//	*qid_PLME_P = msgget(KEY_PLME_P, 0600|IPC_CREAT);

	//!print out for user notification
	printf("Server Queue ID = %d %d %d %d %d %d %d %d\n",*qid_WLME, *qid_ALME, *qid_MLME, *qid_PLME, *qid_WLME_P, *qid_ALME_P, *qid_MLME_P, *qid_PLME_P);
}

/*!void DATA_QUEUE_INIT
 * create different message queues WLPSAP, MACSAP by WLP
 * param[in] int* qid_WLPSAP: pointer auf WLP data queue ID
 * param[in] int* qid_MACSAP: pointer auf MAC data queue ID
 */
void DATA_QUEUE_INIT(int *qid_WLPSAP, int *qid_MACSAP, int *qid_WLPSAP_P, int *qid_MACSAP_P){

	//! realize access to message queue
//	*qid_DATA = msgget(KEY_DATA, 0600|IPC_CREAT);
	*qid_WLPSAP = msgget(KEY_WLPSAP, 0600|IPC_CREAT);
	*qid_MACSAP = msgget(KEY_MACSAP, 0600|IPC_CREAT);

//	*qid_WLPSAP_P = msgget(KEY_WLPSAP_P, 0600|IPC_CREAT);
//	*qid_MACSAP_P = msgget(KEY_MACSAP_P, 0600|IPC_CREAT);

	//! print out for user notification
	printf("Server Queue ID = %d %d %d %d\n",*qid_WLPSAP, *qid_MACSAP, *qid_WLPSAP_P, *qid_MACSAP_P);
}
