/*!
 *  @file STRUCTURES.h
 *
 *  @author Daniel Brockmann
 *  @date 13.05.2010
 *
 *  @version 0.1
 *
 *  @brief contain all main setting fields like WMIB, DME LIST, etc...
 *
*/

//
//#define WSSID_LENGTH 16
//! \define UUID_LENGTH length of UUID
#define UUID_LENGTH 16
//! \define UUID48_LENGTH length of short UUID
#define UUID48_LENGTH 6
//#define SRC_EUI XY
//#define SRC_UUID XY
//#define HIBERNATIONFIELD XY
//#define DRB_LENGTH XY
//#define XXX
//#define CLIENT_DATA XY
//! \define WLP_NAME length of WLP name
#define WLP_NAME 16
//! \define WLP_REVISION length of WLP revision
#define WLP_REVISION 16


//----------------------------------------------------
//Klassen, Strukturen
//----------------------------------------------------

////Standard Datenrahmen
//struct STD_DATA_FRAME{
//
//		unsigned short protocol_id;
//        unsigned char wlp_version;
//        unsigned char wlp_frametype;
//        unsigned char wss_tag;
//        unsigned char dest_addr[LENGTH_ADDR];// Nach Standard 6 Byte
//        unsigned char src_addr[LENGTH_ADDR];// Nach Standard 6 Byte
//        unsigned short length;
//        unsigned char client_data[CLIENT_DATA];//CLIENT_DATA von mir festgelegt
//};

////Association Datenrahmen
//struct ASSOCIATION_FRAME{
//
//        unsigned short protocol_id;
//        unsigned char wlp_version;
//        unsigned char wlp_frametype;
//        unsigned char wss_tag;
//        unsigned char dest_addr[LENGTH_ADDR];// Nach Standard 6 Byte
//        unsigned char src_addr[LENGTH_ADDR];// Nach Standard 6 Byte
//        unsigned short length;
//        unsigned char client_data[CLIENT_DATA];//CLIENT_DATA von mir festgelegt
//};

////WLP Informationselement
//struct WLP_IE{
//
//        unsigned char element_id;
//        unsigned char wlp_version;
//        unsigned char capabilities;
//        unsigned char wss_tag;
//        unsigned char wss_name[WSSID_LENGTH];
//        unsigned short uuid[UUID_LENGTH];
//};

////DME Informationselement
//struct DME_DEVICELIST{
//
//        unsigned char src_eui[SRC_EUI]; //STANDARD should be 6
//        unsigned char src_uuid[SRC_UUID]; //STANDARD should be 6
//        unsigned char hibernation[HIBERNATIONFIELD]; //STANDARD should be 4
//        unsigned char missed_superframe;
//        unsigned char drb[DRB_LENGTH];
//        unsigned char wlp_property;
//        unsigned char rssi;
//        unsigned char lqi;
//        unsigned short wss_field[XXX];
//};

//! \struct WMIB WLP setting parameter
typedef struct WMIB{

        char device_type; //0=Client 1=Node
        char stream_track_enable; //0= StreamTrack OFF 1=StreamTrack ON
        int  number_of_client; //per WSS 0-255 Default=7
        char uuid[UUID_LENGTH];
        char uuid48[UUID48_LENGTH];
        char wlp_name[WLP_NAME];
        char wlp_revision[WLP_REVISION];
        char wss_field[20];
};
