/*!
 *  @file WLME_FUNCTIONS.h
 *
 *  @author Daniel Brockmann
 *  @date 13.05.2010
 *
 *  @version 0.1
 *
 *  @brief contain all WLME primitives
 *
*/

//! standard libraries
#include <iostream>
#include <string>

//! defines all the structures for the different primitives including the corresponding parametes
//#include "STRUCTURES/PRIMITIV_DEF.h"
//! defines  main structures like WMIB, DME LIST,...
#include "../STRUCTURES/STRUCTURES.h"

extern WMIB WLPInfoBase;


/*!int WLME WMIB_GET_REQUEST
 * WLME_WMIB_GET_CONFIRM starten und WMIB an WLME_P übertragen
 * param[out] return 0 = successfull executed
 */
int WLME_WMIB_GET_REQUEST(char MSG[]){

	MSGBUF buf;

	int qid;
	int qid2;
	int Zahl;

	Zahl=sizeof(WLPInfoBase)-4;

	// Buffer leer räumen, damit kein Datenmüll übertragen wird
	memset(buf.msg,0,SIZE);

	// Warteschlangen-ID
	qid = msgget(KEY_WLME, 0600);

	//! \TODO complete
	buf.msg[0]=(char)12;
	buf.msg[1]=Zahl&0x000000ff;
	buf.msg[2]=Zahl>>8&0x000000ff;
	buf.msg[3]=Zahl>>16&0x000000ff;
	buf.msg[4]=Zahl>>24&0x000000ff;

	buf.mtyp = 1;
	msgsnd(qid, &buf, sizeof (MSGBUF), 0);

	printf("in WLME_WMIB_GET_REQUEST - out WLME_WMIB_GET_CONFIRM!!\n");

	//printf("Die Subfunktion WMIB erfolgreich an WLME_P übertragen!!\n");

	return 0;

}


/*!
 *  \TODO init WMIB
 */
void WMIB_DEFAULT_SET(){

	WLPInfoBase.device_type = '0';
	WLPInfoBase.stream_track_enable= '1';
	WLPInfoBase.number_of_client=7;
	strcpy(WLPInfoBase.uuid,"0123456789ABCDEF");
	strcpy(WLPInfoBase.uuid48,"ABCDEF");
	strcpy(WLPInfoBase.wlp_name,"FEDCBA9876543210");
	strcpy(WLPInfoBase.wlp_revision,"X Zeichen voll!");
	strcpy(WLPInfoBase.wss_field,"1A2B3C4D5E6F7G8H9I0J");

}
